#include "spawn.h"

#include "..\algorithms.h"

#include "..\dllcore.cpp"
#include "..\datatypes.cpp"
#include "..\algorithms.cpp"
#include "..\player.cpp"
#include "..\commtypes.cpp"

#define UNASSIGNED 0xffff


//////// Bot list ////////

_linkedlist <botInfo> botlist;

botInfo *findBot(CALL_HANDLE handle)
{
	_listnode <botInfo> *parse = botlist.head;

	while (parse)
	{
		botInfo *item = parse->item;

		if (item->validate(handle))
			return item;

		parse = parse->next;
	}

	return 0;
}

//////// My Code /////////////

void botInfo::LoadLimitBotIni() //loads settings and all the freq files
{
	char buffer[50]; //holds the input from the file
	char Path[512]; //file path
	GetCurrentDirectory(512, Path); //grab the path
	strcat(Path, "\\LimitBot.ini"); //append the file name

	if(Exists(Path)) //make sure file exists
	{
		Uint16 TotalFiles=0; //hold the total num of files
		String FreqFile; //used to get each file, ex- File1, File2

		ZeroMemory(buffer, 50); //place null in string
		GetPrivateProfileString("BotSettings", "ShipLimit", NULL, buffer, 2, Path); //Shiplimits start, ON or OFF
		if(buffer[0] && isNumeric(buffer) && getInteger(buffer, 10) > 0)//if it was a number, and the number is > 0
		{ShipLimitsStatus=true;} //then turn on shiplimits

		ZeroMemory(buffer, 50); //place null in string
		GetPrivateProfileString("BotSettings", "AttachLimit", NULL, buffer, 2, Path); //Attach limits start, ON or OFF
		if(buffer[0] && isNumeric(buffer) && getInteger(buffer, 10) > 0)//check if its a number and that the number is > 0
		{AttachLimitsStatus=true;}// then turn on attachlimits
	
		ZeroMemory(buffer, 50); //place null in string
		GetPrivateProfileString("FreqFiles", "TotalFiles", "0", buffer, 5, Path); //get the total number of files
		if(buffer[0] && isNumeric(buffer)) //if there is something there
		{TotalFiles=getInteger(buffer,10);} //then store the total number

		while(TotalFiles) //while there are files
		{
			FreqFile="File"; //ex- File1
			FreqFile+=TotalFiles;
			ZeroMemory(buffer, 50); //null in string
			GetPrivateProfileString("FreqFiles", FreqFile.msg, NULL, buffer, 50, Path); //get the file name
			if(buffer[0]) //if there was a name there
			{LoadFreqIni(buffer);} //then load the file's values
			TotalFiles--; //1 file done
		}
	}
}

void botInfo::LoadFreqIni(char *FileName) //Loads a freq file
{
	char Path[512]; //file path
	GetCurrentDirectory(512, Path); //grab the path
	strcat(Path, "\\"); 
	strcat(Path, FileName);//append the file name

	if(Exists(Path)) //make sure the file exists
	{
		char buffer[20]; //holds the input from the file
		ZeroMemory(buffer, 20); //place null in string
		GetPrivateProfileString("FreqSettings", "FreqNum", NULL, buffer, 5, Path); //get the freq number
		if(buffer[0] && isNumeric(buffer))
		{
			Uint16 FreqNum= getInteger(buffer, 10);
			if(!FindFreq(FreqNum))
			{
				String ShipType; //gets the shipname
				FreqShips *NewFreq=new FreqShips; //make a new freq
				NewFreq->FreqNum=FreqNum; //set the freq number
				Uint16 i; //indexing
				Sint32 k; //indexing

				for(i=0;i<8;i++) //intialize values
				{
					NewFreq->Ship[i].ShipLimit=false;
					for(k=0;k<8;k++)
					{NewFreq->Ship[i].NoAttach[k]=false;}
				}

				for(i=0; i < 8 ; i++) // (index) i= shipnumbers// 0=warbird through 7=shark
				{
					ShipType= ShipToString(i);//get the original shipnames for gathering info from file
	
					ZeroMemory(buffer, 20); //place null in string
					GetPrivateProfileString(ShipType.msg, "NoAttach", NULL, buffer, 16, Path);//input from file
					if(buffer[0])//if there was something that cant attach to a ship
					{
						for(k=STRLEN(buffer)-1;k >= 0;k--) //cycle through buffer
						{
							if (buffer[k] >= '1' && buffer[k] <= '8') //if the ship is a ship 1-8
							{
								NewFreq->Ship[i].NoAttach[buffer[k]-'1']= true; //convert char to index value
							}
						}	
					}
		
					ZeroMemory(buffer, 20);//null the string
					GetPrivateProfileString(ShipType.msg, "MaxNumber", NULL, buffer, 5, Path);//get max number of ships allowed
					if(buffer[0])//if there is a number there
					{
						if (isNumeric(buffer)) //check if its a number
						{
							NewFreq->Ship[i].MaxShips=Uint16(getInteger(buffer, 10));//turn it into a integer
							NewFreq->Ship[i].ShipLimit=true; //turn on the limit
						}
						else
						{
							tell(makeEcho("Invalid MaxShips: Unrecognizable Character!"));
						}
					}
			
					ZeroMemory(buffer, 20);//null the string
					GetPrivateProfileString(ShipType.msg, "Name", NULL, buffer, 20, Path); //Gather Custom names for ships
					if(buffer[0]) //if there was something in the string
					{NewFreq->Ship[i].ShipName= buffer;} //if there is a ship name, make it the buffer
					else
					{NewFreq->Ship[i].ShipName=ShipToString(i);} //else, standard ship name
				}
				FreqList.append(NewFreq); //append it to list
			}
			else
			{tell(makeEcho("File Error: That Freq already exists and is loaded!"));}

		}
		else
		{tell(makeEcho("Invalid Freq Number: Freq Number MUST be a number"));}
	}
	else
	{tell(makeEcho("File Error: File does not exist!"));}
}

bool botInfo::Exists(LPSTR lpszFilename) //checks if file Exists
{
	bool Found=false;
	DWORD dwAttr = GetFileAttributes(lpszFilename);
	if (dwAttr != 0xffffffff)
	{Found=true;}
	return Found;
}

FreqShips* botInfo::FindFreq(Uint16 FreqNum) //returns a listnode pointer from a freq num
{
	_listnode <FreqShips> *fl= FreqList.head; //top of the freq list
	FreqShips *Freq=NULL; //set return to null

	while(fl)
	{
		if(fl->item->FreqNum == FreqNum) //if the freqs match
		{
			Freq=fl->item; //set pointer to item and return it
			break;
		}
		fl=fl->next;
	}

	return Freq;
}

String botInfo::ShipToString(Uint16 Ship) //Converts ship numbers to String Names, 0=Warbird - 7=Shark
{
	String ShipType; //return value for ship

	switch(Ship) //Switch between ship type
	{
	case 0:
		ShipType= "Warbird";
		break;
	case 1:
		ShipType= "Javelin";
		break;
	case 2:
		ShipType= "Spider";
		break;
	case 3:
		ShipType= "Leviathan";
		break;
	case 4:
		ShipType= "Terrier";
		break;
	case 5:
		ShipType= "Weasel";
		break;
	case 6:
		ShipType= "Lancaster";
		break;
	case 7:
		ShipType= "Shark";
		break;
	default:
		break;
	}
	return ShipType; //return string of shipname
}

void botInfo::StartShipLimits() //Starts Shiplimits
{
	_listnode <Player> *pl= playerlist->head; //get the player list

	while(pl)
	{
		if(pl->item->ship != 8) //ignore those people in spec
		{
			gotEvent(makePlayerShip(pl->item,8,pl->item->team)); //run the event function for ship changes
		}
		pl=pl->next;
	}
}

void botInfo::StopShipLimits() //stops the shiplimits, returns limits to normal
{
	_listnode <Player> *pl= playerlist->head;
	FreqShips *Freq;

	while(pl)
	{
		if(pl->item->ship != 8) //ignore players in spec
		{
			Freq=FindFreq(pl->item->team);
			if(Freq != NULL && Freq->Ship[pl->item->ship].ShipLimit) //if they are on a limited freq and in a ship with a limit
			{
				Freq->Ship[pl->item->ship].MaxShips++; //delete them from the limit
			}	
		}
		pl=pl->next;
	}
}

void botInfo::StartAttachLimits() //Starts attach limits
{
	_listnode <Player> *pl= playerlist->head; //top of player list

	while(pl)
	{
		if(pl->item->turret != NULL) //if they are on a turret
		{
			gotEvent(makeCreateTurret(pl->item, pl->item->turret)); // run create turret funtion
		}
		pl=pl->next;
	}
}

void botInfo::RemoveAttachedPlayer(Player *p) //removes attached player
{
	Uint16 bounty= p->bounty; //store thier bounty
	Uint16 FreqNum= p->team; //store team
	Sint16 FreqChange=9999; //use to setfreq them off turret
	Vector Coord= p->tile;
	String Command;

	while(!FindLegalShip(FreqChange))//if there isnt a legal ship on the change freq
	{
		FreqChange--; //then decrement the freq
		if(FreqChange < 0) //if freqchange is ever less than 0, which would probably never happen
		{
			FreqChange=FreqNum; //then dont move them
			break;
		}
	}

	Command="*setfreq ";
	Command+=FreqChange;
	sendPrivate(p,  Command);//remove them from turret

	Command="*setfreq ";
	Command+=FreqNum;
	sendPrivate(p, Command); //set them back to thier old freq

	Command= "*warpto ";
	Command+= Coord.x;
	Command+= " ";
	Command+= Coord.y;
	sendPrivate(p, Command); //set them back to thier place

	if(bounty > settings->ships[p->ship].InitialBounty) //if thier old bty is larger than initial bounty
	{
		bounty -= settings->ships[p->ship].InitialBounty; //initial bounty is subtracted from old bounty
		sendPrivate(p, "*prize " + (String)bounty); //add on the remaining bounty to the player
	}
}

Uint16 botInfo::FindLegalShip(Uint16 FreqNum) //finds a legal ship for the ship limit
{
	FreqShips *Freq=FindFreq(FreqNum);
	Uint16 LegalShip= 1; //start at ship 1 and count up. 
	//Starting at 8 would be more efficient but kinda wierd to start as ship 8,7,6,ect

	if(Freq != NULL)
	{
		while(LegalShip <= 8) //count until the ship is ship 8, shark
		{
			if(Freq->Ship[LegalShip-1].ShipLimit) //if the ship has a limit
			{
				if(Freq->Ship[LegalShip-1].MaxShips > 0) //if there is space for that ship
				{break;}//return the ship
			}
			else //if there is no ship limit
			{break;} //return the ship
			LegalShip++; //count up ships, 1,2,3,ect
		}
	}
	if(LegalShip==9) //if there arnt any open ships, make return false
	{LegalShip=0;}

	return LegalShip; //return the ship number
}

Sint32 botInfo::FindLegalFreq()
{
	Sint32 MaxFrequency=Sint32(settings->MaxFrequency); //get the max amount of freqs
	for(Sint32 FreqNum=0;FreqNum<MaxFrequency;FreqNum++) //increment up the freqs
	{
		if(FindLegalShip(Uint16(FreqNum))) //if there is a legal ship in any of them
		{break;} //break outta loop
	}
	if(FreqNum == MaxFrequency) //if there isnt any legal freqs
	{FreqNum=-1;} //then return a negative number

	return FreqNum;
}

//////// DLL "import" ////////

void botInfo::tell(BotEvent &event)
{
	if (callback && handle)
	{
		event.handle = handle;
		callback(event);
	}
}

void botInfo::gotEvent(BotEvent &event)
{
	if (CONNECTION_DENIED) return;

	switch (event.code)
	{
//////// Periodic ////////
	case EVENT_Tick:
		{
			for (int i = 0; i < 4; ++i)
				--countdown[i];
		}
		break;
//////// Arena ////////
	case EVENT_ArenaEnter:
		{
			arena = (char*)event.p[0];
			me = (Player*)event.p[1];	// if(me) {/*we are in the arena*/}
			bool biller_online = *(bool*)&event.p[2];

			if(ShipLimitsStatus) //if shiplimits are on
			{StartShipLimits();}//then start them
			if(AttachLimitsStatus) // if attachlimits are on
			{StartAttachLimits();}//then start them

		}
		break;
	case EVENT_ArenaSettings:
		{
			settings = (arenaSettings*)event.p[0];
		}
		break;
	case EVENT_ArenaLeave:
		{
			me = 0;
			killTags();

			if(ShipLimitsStatus) //leaving the arena and the limits are on
			{StopShipLimits();}//stop them
		}
		break;
	case EVENT_ArenaListEntry:
		{
			char *name = (char*)event.p[0];
			bool current = *(bool*)&event.p[1];
			int population = *(int*)&event.p[2];
		}
		break;
	case EVENT_ArenaListEnd:
		{
			char *name = (char*)event.p[0];
			bool current = *(bool*)&event.p[1];
			int population = *(int*)&event.p[2];
		}
		break;
//////// Flag ////////
	case EVENT_FlagGrab:
		{
			Player *p = (Player*)event.p[0];
			Flag *f = (Flag*)event.p[1];
		}
		break;
	case EVENT_FlagDrop:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_FlagMove:
		{
			Flag *f = (Flag*)event.p[0];
		}
		break;
	case EVENT_FlagVictory:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
	case EVENT_FlagGameReset:
		{
		}
		break;
	case EVENT_FlagReward:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
//////// Timed ////////
	case EVENT_TimedGameOver:
		{
			Player *p[5];
			for (int i = 0; i < 5; i++)
				p[i] = (Player*)event.p[i];
		}
		break;
//////// Soccer ////////
	case EVENT_SoccerGoal:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
	case EVENT_BallMove:
		{
			PBall *ball = (PBall*)event.p[0];
		}
		break;
//////// File ////////
	case EVENT_File:
		{
			char *name = (char*)event.p[0];
		}
		break;
//////// Player ////////
	case EVENT_PlayerEntering:
		{
			Player *p = (Player*)event.p[0];

			if(ShipLimitsStatus && p->ship != 8) //if the shiplimits are ON and the player isnt in spec
			{gotEvent(makePlayerShip(p,8,p->team));} //run shipchange function
		}
		break;
	case EVENT_PlayerMove:
		{
			Player *p = (Player*)event.p[0];	
		}
		break;
	case EVENT_PlayerWeapon:
		{
			Player *p = (Player*)event.p[0];
			weaponInfo wi;
			wi.n = *(Uint16*)&event.p[1];
		}
		break;
	case EVENT_WatchDamage:
		{
			Player *p = (Player*)event.p[0];	// player
			Player *k = (Player*)event.p[1];	// attacker
			weaponInfo wi;
			wi.n = *(Uint16*)&event.p[2];
			Uint16 energy = *(Uint16*)&event.p[3];
			Uint16 damage = *(Uint16*)&event.p[4];
		}
		break;
	case EVENT_PlayerDeath:
		{
			Player *p = (Player*)event.p[0],
				   *k = (Player*)event.p[1];
			Uint16 bounty = (Uint16)event.p[2];
		}
		break;
	case EVENT_PlayerScore:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_PlayerPrize:
		{
			Player *p = (Player*)event.p[0];
			int prize = *(int *)&event.p[1];
		}
		break;
	case EVENT_PlayerShip: //happens durring shipchange
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldship = (Uint16)event.p[1];
			Uint16 oldteam = (Uint16)event.p[2];

			if(ShipLimitsStatus) //if the shiplimits are ON
			{
				FreqShips *Freq=FindFreq(p->team); //get the Freq info from linkedlist
				if(Freq != NULL) //if the player is on a limited freq
				{
					if(Freq->Ship[p->ship].ShipLimit) //if the ship has a limit
					{
						if(Freq->Ship[p->ship].MaxShips > 0) //if there is room in the limit
						{
							if(oldship != 8) //if they didnt come from spec
							{
								if(Freq->Ship[oldship].ShipLimit) //if thier oldship had a limit
								{Freq->Ship[oldship].MaxShips++;} //delete them from oldship limit
							}
							if(Freq->Ship[p->ship].ShipLimit) //if thier new ship has a limit
							{Freq->Ship[p->ship].MaxShips--;}//add them to limit
						}
						else //if there wasnt any room for them in limit
						{
							String ShipChange= "*setship "; //prepare a *setship
							String Message; //sends notice message

							if(Freq->Ship[p->ship].ShipLimit) //add them to limit
							{Freq->Ship[p->ship].MaxShips--;}

							if(oldship != 8) //if they didnt come from spec
							{
								if(Freq->Ship[oldship].ShipLimit) //delete them from oldship limit
								{Freq->Ship[oldship].MaxShips++;}
					
								ShipChange+=oldship + 1; //add oldship number to *setship

								//prepare nice string message
								Message= "Ship Limits: That Ship (Ship#";
								Message+= p->ship +1;
								Message+= ":";
								Message+= Freq->Ship[p->ship].ShipName;
								Message+= ") is Currently in Use on this Freq. Type ::!shiplimits to Recieve the Current Limits";
							}
							else //if they came from spec
							{
								Uint16 LegalShip=FindLegalShip(p->team); //find a legal ship
								if(LegalShip) //if there is a legal ship
								{
									ShipChange+= LegalShip; //place legal ship with *setship
	
									//notice message
									Message= "Ship Limits: That Ship (Ship#";
									Message+= p->ship +1;
									Message+= ":";
									Message+= Freq->Ship[p->ship].ShipName;
									Message+= ") is Currently in Use on this Freq. Type ::!shiplimits to Recieve the Current Limits";
								}
								else //if no legal ship
								{
									Sint32 LegalFreq=FindLegalFreq();
									if(LegalFreq == -1) //if there are no legal ships
									{
										ShipChange= "*spec"; //spectate player
										sendPrivate(p,ShipChange);
									}
									else
									{
										ShipChange= "*setfreq ";//setfreq them to another legal freq
										ShipChange+= LegalFreq;
									}
									Message= "Ship Limits: All Ships are Currently in Use on that Freq. Type ::!shiplimits to Recieve the Current Limits";
								}
							}
							sendPrivate(p, Message);//send notice message
							sendPrivate(p, ShipChange);//send command
						}
					}
					else //if there isnt a ship limit
					{
						if(oldship != 8) //if they didnt come from spec
						{
							if(Freq->Ship[oldship].ShipLimit)//if thier oldship has a limit
							{Freq->Ship[oldship].MaxShips++;} //delete them from oldship limit
						}
					}
				}
			}
		}
		break;
	case EVENT_PlayerSpec:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldteam = (Uint16)event.p[1];
			Uint16 oldship = (Uint16)event.p[2];

			if(ShipLimitsStatus) //if the ship limit is ON
			{
				FreqShips *Freq=FindFreq(oldteam);
				if(Freq != NULL && Freq->Ship[oldship].ShipLimit)// if the ship they were in has a limit
				{Freq->Ship[oldship].MaxShips++;}//delete player from limit
			}
		}
		break;
	case EVENT_PlayerTeam:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldteam = (Uint16)event.p[1];
			Uint16 oldship = (Uint16)event.p[2];

			if(ShipLimitsStatus && oldship != 8) //if they didnt come from spec and the shiplimit is on
			{
				FreqShips *Freq=FindFreq(oldteam);//get freq info from thier old freq
				if(Freq != NULL && Freq->Ship[oldship].ShipLimit) //if the freq had a ship limit
				{Freq->Ship[oldship].MaxShips++;} //delete them from old limit

				gotEvent(makePlayerShip(p,8,oldteam)); //add them to new limit
			}

		}
		break;
	case EVENT_PlayerLeaving:
		{
			Player *p = (Player*)event.p[0];
			
			if(ShipLimitsStatus && p->ship != 8) //if the shiplimits are ON, the player isnt in spec, and they fall into a shiplimit
			{
				FreqShips *Freq=FindFreq(p->team);
				if(Freq != NULL && Freq->Ship[p->ship].ShipLimit)
				{Freq->Ship[p->ship].MaxShips++;} //delete player from limit
			}
			killTags(p);
		}
		break;
//////// Selfish ////////
	case EVENT_SelfShipReset:
		{
		}
		break;
	case EVENT_SelfPrize:
		{
			Uint16 prize = (Uint16)event.p[0];
			Uint16 count = (Uint16)event.p[1];
		}
		break;
	case EVENT_SelfUFO:
		{
		}
		break;
	case EVENT_PositionHook:
		{
		}
		break;
//////// Bricks ////////
	case EVENT_BrickDropped:
		{
			int x1 = *(int*)&event.p[0];
			int y1 = *(int*)&event.p[1];
			int x2 = *(int*)&event.p[2];
			int y2 = *(int*)&event.p[3];
			int team = *(int*)&event.p[4];
		}
		break;
//////// LVZ ////////
	case EVENT_ObjectToggled:
		{
			objectInfo obj;
			obj.n = (Uint16)event.p[0];
		}
		break;
//////// Turret ////////
	case EVENT_CreateTurret:
		{
			Player *turreter = (Player*)event.p[0];
			Player *turretee = (Player*)event.p[1];

			if(AttachLimitsStatus) //if attachlimits are on
			{
				FreqShips *Freq=FindFreq(turreter->team);
				if(Freq->Ship[turreter->ship].NoAttach[turretee->ship])//if player attaches to a illegal ship
				{
					//send a nice message
					String Message= "Illegal Ship Attach: You may not attach to (Ship#";
					Message+= turretee->ship;
					Message+= ":";
					Message+= Freq->Ship[turretee->ship].ShipName;
					Message+= ") Type ::!myattachlimit for Attach Limits. Your Bounty, Ship, and Freq have been restored";
					RemoveAttachedPlayer(turreter);//remove them from attach
					sendPrivate(turreter, Message); //send message
				}
			}
		}
		break;
	case EVENT_DeleteTurret:
		{
			Player *turreter = (Player*)event.p[0];
			Player *turretee = (Player*)event.p[1];
		}
		break;
//////// Chat ////////
	case EVENT_Chat:
		{
			int type  = *(int*)&event.p[0];
			int sound = *(int*)&event.p[1];
			Player *p = (Player*)event.p[2];
			char *msg = (char*)event.p[3];

			switch (type)
			{
			case MSG_Arena:
				{
				}
				break;
			case MSG_PublicMacro:		if (!p) break;
				{
				}
				break;
			case MSG_Public:			if (!p) break;
				{
				}
				break;
			case MSG_Team:				if (!p) break;
				{
				}
				break;
			case MSG_TeamPrivate:		if (!p) break;
				{
				}
				break;
			case MSG_Private:			if (!p) break;
				{
				}
				break;
			case MSG_PlayerWarning:		if (!p) break;
				{
				}
				break;
			case MSG_RemotePrivate:
				{
				}
				break;
			case MSG_ServerError:
				{
				}
				break;
			case MSG_Channel:
				{
				}
				break;
			};
		}
		break;
	case EVENT_LocalCommand:
		{
			Player *p = (Player*)event.p[0];
			Command *c = (Command*)event.p[1];

			gotCommand(p, c);
		}
		break;
	case EVENT_LocalHelp:
		{
			Player *p = (Player*)event.p[0];
			Command *c = (Command*)event.p[1];

			gotHelp(p, c);
		}
		break;
	case EVENT_RemoteCommand:
		{
			char *p = (char*)event.p[0];
			Command *c = (Command*)event.p[1];
			Operator_Level o = *(Operator_Level*)&event.p[2];

			gotRemote(p, c, o);
		}
		break;
	case EVENT_RemoteHelp:
		{
			char *p = (char*)event.p[0];
			Command *c = (Command*)event.p[1];
			Operator_Level o = *(Operator_Level*)&event.p[2];

			gotRemoteHelp(p, c, o);
		}
		break;
//////// Containment ////////
	case EVENT_Init:
		{
			int major	= HIWORD(*(int*)&event.p[0]);
			int minor	= LOWORD(*(int*)&event.p[0]);
			callback	= (CALL_COMMAND)event.p[1];
			playerlist	= (CALL_PLIST)event.p[2];
			flaglist	= (CALL_FLIST)event.p[3];
			map			= (CALL_MAP)event.p[4];
			bricklist	= (CALL_BLIST)event.p[5];

			if (major > CORE_MAJOR_VERSION)
			{
				tell(makeEcho("DLL plugin cannot connect.  This plugin is out of date."));

				CONNECTION_DENIED = true;

				return;
			}
			else if ((major < CORE_MAJOR_VERSION) || (minor < CORE_MINOR_VERSION))
			{
				tell(makeEcho("DLL plugin cannot connect.  This plugin requires the latest version of MERVBot."));

				CONNECTION_DENIED = true;

				return;
			}
			else
				tell(makeEcho("DLL plugin connected."));

			LoadLimitBotIni(); //Load the Settings files
		}
		break;
	case EVENT_Term:
		{
			tell(makeEcho("DLL plugin disconnected."));
		}
		break;
	};
}


//////// DLL export ////////

_declspec(dllexport) void __stdcall talk(BotEvent &event)
{
	botInfo *bot;

	bot = findBot(event.handle);

	if (!bot)
	{
		bot = new botInfo(event.handle);
		botlist.append(bot);
	}

	if (bot) bot->gotEvent(event);
}


//////// Tag emulation ////////

int botInfo::get_tag(Player *p, int index)
{
	_listnode <PlayerTag> *parse = taglist.head;
	PlayerTag *tag;

	while (parse)
	{
		tag = parse->item;

		if (tag->p == p)
		if (tag->index == index)
			return tag->data;

		parse = parse->next;
	}

	return 0;
}

void botInfo::set_tag(Player *p, int index, int data)
{
	_listnode <PlayerTag> *parse = taglist.head;
	PlayerTag *tag;

	while (parse)
	{
		tag = parse->item;

		if (tag->p == p)
		if (tag->index == index)
		{
			tag->data = data;
			return;
		}

		parse = parse->next;
	}

	tag = new PlayerTag;
	tag->p = p;
	tag->index = index;
	tag->data = data;
	taglist.append(tag);
}

void botInfo::killTags(Player *p)
{
	_listnode <PlayerTag> *parse = taglist.head;
	PlayerTag *tag;

	while (parse)
	{
		tag = parse->item;
		parse = parse->next;

		if (tag->p != p) continue;

		taglist.kill(tag);
	}
}

void botInfo::killTags()
{
	taglist.clear();
}


//////// LVZ Object Toggling ////////

void botInfo::clear_objects()
{
	num_objects = 0;
}

void botInfo::object_target(Player *p)
{
	object_dest = p;
}

void botInfo::toggle_objects()
{
	Player *p = object_dest;

	if (!p)	tell(makeToggleObjects(UNASSIGNED, (Uint16 *)object_array, num_objects));
	else	tell(makeToggleObjects(p->ident, (Uint16 *)object_array, num_objects));

	num_objects = 0;
}

void botInfo::queue_enable(int id)
{
	if (num_objects == MAX_OBJECTS)
		toggle_objects();

	object_array[num_objects].id = id;
	object_array[num_objects].disabled = false;
	++num_objects;
}

void botInfo::queue_disable(int id)
{
	if (num_objects == MAX_OBJECTS)
		toggle_objects();

	object_array[num_objects].id = id;
	object_array[num_objects].disabled = true;
	++num_objects;
}


//////// Chatter ////////

void botInfo::sendPrivate(Player *player, BYTE snd, char *msg)
{
	tell(makeSay(MSG_Private, snd, player->ident, msg));
}

void botInfo::sendPrivate(Player *player, char *msg)
{
	tell(makeSay(MSG_Private, 0, player->ident, msg));
}

void botInfo::sendTeam(char *msg)
{
	tell(makeSay(MSG_Team, 0, 0, msg));
}

void botInfo::sendTeam(BYTE snd, char *msg)
{
	tell(makeSay(MSG_Team, snd, 0, msg));
}

void botInfo::sendTeamPrivate(Uint16 team, char *msg)
{
	tell(makeSay(MSG_TeamPrivate, 0, team, msg));
}

void botInfo::sendTeamPrivate(Uint16 team, BYTE snd, char *msg)
{
	tell(makeSay(MSG_TeamPrivate, snd, team, msg));
}

void botInfo::sendPublic(char *msg)
{
	tell(makeSay(MSG_Public, 0, 0, msg));
}

void botInfo::sendPublic(BYTE snd, char *msg)
{
	tell(makeSay(MSG_Public, snd, 0, msg));
}

void botInfo::sendPublicMacro(char *msg)
{
	tell(makeSay(MSG_PublicMacro, 0, 0, msg));
}

void botInfo::sendPublicMacro(BYTE snd, char *msg)
{
	tell(makeSay(MSG_PublicMacro, snd, 0, msg));
}

void botInfo::sendChannel(char *msg)
{
	tell(makeSay(MSG_Channel, 0, 0, msg));
}

void botInfo::sendRemotePrivate(char *msg)
{
	tell(makeSay(MSG_RemotePrivate, 0, 0, msg));
}

void botInfo::sendRemotePrivate(char *name, char *msg)
{
	String s;
	s += ":";
	s += name;
	s += ":";
	s += msg;

	sendRemotePrivate(s);
}
